# frozen_string_literal: true

module Headway
  class Processor
    MARKER = '<!-- GENERATED BY HEADWAY PROGRESS REPORT DO NOT EDIT -->'
    SPACER = ' '
    attr_reader :merge_requests, :issues, :milestones

    def initialize
      @cur_milestone = ''
      @merge_requests = []
      @issues = []
      @milestones = []
    end

    def execute
      report_format = Config.report_format
      if report_format == 'EPIC_ISSUES_BY_MILESTONE_TOTAL'
        logger.info('Fetching issues for epic')

        each_marked_epic_issue { |issue| issues << issue }

        logger.info('Composing report')

        report = create_report('', report_format)
      elsif report_format == 'MILESTONE_MR_ISSUE_TOTAL'
        logger.info('Fetching merge requests')

        each_marked_merge_request { |merge_request| merge_requests << merge_request }

        logger.info('Fetching issues')

        each_marked_issue { |issue| issues << issue }

        logger.info('Composing report')

        report = create_report('', report_format)
      else
        ## Fetch milestones for loop
        report2 = [MARKER]
        each_milestones { |milestone| milestones << milestone }
        @milestones.each do |milestone|
          @cur_milestone = milestone.title
          ## if milestone value is in the proper ##.## notation, it's a valid milestone to check.
          if @cur_milestone.length < 6
            logger.info('Fetching merge requests for ' + milestone.title)

            each_marked_merge_request { |merge_request| merge_requests << merge_request }

            logger.info('Fetching issues for ' + milestone.title)

            each_marked_issue { |issue| issues << issue }

            logger.info('Composing report for ' + milestone.title)

            report = create_report(milestone.title, report_format)

            report2 += [report] unless report.nil?
            @merge_requests = []
            @issues = []
          end
          report = report2
        end
        report << Config.configuration_details
        report << MARKER
      end
      logger.info("\n#{report}\n")
      update_epic(report)
    end

    def each_milestones(&block)
      Gitlab.group_milestones(9970).auto_paginate(&block)
    end

    def each_marked_merge_request(&block)
      Gitlab.user_merge_requests(
        scope: 'all',
        order_by: 'created_at',
        sort: 'asc',
        milestone: @cur_milestone,
        labels: Config.tracking_label
      ).auto_paginate(&block)
    end

    def each_marked_epic_issue(&block)
      Gitlab.epic_issues(
        '9970',
        Config.epic_id
      ).auto_paginate(&block)
    end

    def each_marked_issue(&block)
      Gitlab.issues(
        nil,
        scope: 'all',
        state: 'opened',
        order_by: 'created_at',
        sort: 'asc',
        milestone: @cur_milestone,
        labels: Config.tracking_label
      ).auto_paginate(&block)
    end

    def assoc_mrs
      assoc_mrs = {}
      @merge_requests.each do |mr|
        m = (mr.milestone ? mr.milestone.title : 'No milestone')
        assoc_mrs[m] = [] if assoc_mrs[m].nil?
        assoc_mrs[m].append(mr)
      end
      return assoc_mrs unless assoc_mrs.nil?
    end

    def assoc_issues
      assoc_issues = {}
      @issues.each do |issue|
        m = (issue.milestone ? issue.milestone.title : 'No milestone')
        assoc_issues[m] = [] if assoc_issues[m].nil?
        assoc_issues[m].append(issue)
      end
      return assoc_issues unless assoc_issues.nil?
    end

    def create_report(milestone, report_format)
      if report_format == 'EPIC_ISSUES_BY_MILESTONE_TOTAL'
        report = [MARKER]
        add_epic_issues_to_report(report)
        report << Config.configuration_details
        report << MARKER
        report.join("\n")
      elsif report_format == 'MILESTONE_MR_ISSUE_TOTAL'
        report = [MARKER]
        add_milestones_to_report(report)
        add_issues_to_report(report)
        report << Config.configuration_details
        report << MARKER
        report.join("\n")
      else
        add_mrs_issues_to_milestone(milestone)
      end
    end

    def sort_weight(milestone)
      return 99 if milestone == 'No milestone'
      return 100 if milestone == 'Backlog'

      milestone.split('.').map { |part| part.rjust(2, '0') }.join('.').to_f
    end

    def generate_mr_content(milestone)
      return unless @merge_requests.length.positive?

      report = [SPACER]
      report << '<details><summary>' + milestone + ' Milestone</summary>'
      report << '' << table_header
      assoc_mrs.each do |mr_milestone, mrs|
        next if mr_milestone != milestone

        mrs.each { |mr| report << MergeRequestReportItem.new(mr).to_row }
      end
      return report unless report.nil?
    end

    def generate_issue_content(report, milestone)
      if @issues.length.positive?
        ## If there are issues in milestone but no associated MRs, start the section.
        if @merge_requests.length.zero?
          report = [SPACER]
          report << '<details><summary>' + milestone + ' Milestone</summary>'
          report << '' << table_header
        end
        assoc_issues.each do |issue_milestone, issues|
          next if issue_milestone != milestone

          issues.each { |issue| report << IssueReportItem.new(issue).to_row }
        end
        ## Close after loop
        report << '</details>'
      ## No issues so close if there are associated MRs.
      elsif @merge_requests.length.positive?
        report << '</details>'
      end
      return report unless report.nil?
    end

    def add_mrs_issues_to_milestone(milestone)
      report = generate_mr_content(milestone)

      report = generate_issue_content(report, milestone)

      report.join("\n") if @merge_requests.length.positive? || @issues.length.positive?
    end

    def add_milestones_to_report(report)
      @milestones_to_mrs ||= @merge_requests.group_by { |mr| mr.milestone&.title || 'No milestone' }

      report << format('<details><summary>MRs (total: %<total>d)</summary>', total: @merge_requests.length)
      @milestones_to_mrs.keys.sort { |a, b| sort_weight(a) <=> sort_weight(b) }.each do |milestone|
        mrs = @milestones_to_mrs[milestone]
        report << format('<details><summary>%<summary>s (%<total>d)</summary>', summary: milestone, total: mrs.length)
        report << '' << table_header
        mrs.each { |mr| report << MergeRequestReportItem.new(mr).to_row }
        report << '</details>'
      end
      report << '</details>'
    end

    def add_epic_issues_to_report(report)
      @epic_issues ||= @issues.group_by { |issue| issue.milestone&.title || 'No milestone' }

      report << format('<details><summary>Issues (total: %<total>d)</summary>', total: @issues.length)
      @epic_issues.keys.sort { |a, b| sort_weight(a) <=> sort_weight(b) }.each do |milestone|
        rec = @epic_issues[milestone]
        report << format('<details><summary>%<summary>s (%<total>d)</summary>', summary: milestone, total: rec.length)
        report << '' << table_header
        rec.each { |issue| report << EpicIssueReportItem.new(issue).to_row }
        report << '</details>'
      end
      report << '</details>'
    end

    def add_issues_to_report(report)
      report << format('<details><summary>Issues (total: %<total>d)</summary>', total: @issues.length)
      report << '' << table_header
      @issues.each do |issue|
        next if issue.assignees.any?

        report << IssueReportItem.new(issue).to_row
      end
      report << '</details>'
    end

    def update_epic(report)
      epic = Gitlab.epic(*Config.epic_reference.split('&'))

      description = epic.description
      description = replace_report(description, report)

      logger.info("Updating epic #{Config.epic_reference}")

      if Config.dry_run?
        logger.info('Running in dry mode, skipping update')
      else
        Gitlab.edit_epic(epic.group_id, epic.iid, description: description)
      end
    end

    def replace_report(description, report)
      if description.include?(MARKER)
        logger.info('Replacing the current report from the description')

        description = description.split(MARKER)
        description[1] = report
        description.join('')
      else
        logger.info('The report was not detected in the description, appending...')

        description + "\n\n" + report
      end
    end

    def table_header
      ['| :checkered_flag: | Iteration | References | Status / ETA | DRI | Impact |',
       '| --- | --- | --- | --- | --- | --- |']
    end

    def logger
      @logger ||= Logger.new($stderr)
    end
  end
end
